#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname	udev
%define		lfsvers		20230818
#-----------------------------------------------------------------------------
Name		:	eudev
Version		:	3.2.14
Release		:	17.2.0.rel%{?dist}
Summary		:	A userspace implementation of devfs
Group		:	System Environment/Base

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	http://dev.gentoo.org/~blueness/eudev

Source0		:	%{name}-%{version}.tar.gz
			#https://anduin.linuxfromscratch.org/LFS
Source1		:	udev-lfs-%{lfsvers}.tar.xz
Source2		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
Buildrequires	:	kmod
Buildrequires	:	util-linux
Buildrequires	:	xz-devel

Requires(pre)	:	kmod,util-linux
#-----------------------------------------------------------------------------
%description
Starting with the 2.5 kernel, all physical and virtual devices in a
system are visible to userspace in a hierarchal fashion through
sysfs. /sbin/hotplug provides a notification to userspace when any
device is added or removed from the system. Using these two features,
a userspace implementation of a dynamic /dev is now possible that can
provide a very flexible device naming policy

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING
%{_sysconfdir}/%{sname}/%{sname}.conf
%{_sysconfdir}/%{sname}/rules.d/*.rules
%{_sysconfdir}/%{sname}/hwdb.d/[1-9]0-*.hwdb
%{_sysconfdir}/rc.d/init.d/%{sname}
%{_sysconfdir}/rc.d/rcS.d/S10%{sname}
%{_sbindir}/%{sname}d
%{_sbindir}/%{sname}adm
%{_bindir}/%{sname}adm
%{_libdir}/%{sname}/init-net-rules.sh
%{_libdir}/%{sname}/rule_generator.functions
%{_libdir}/%{sname}/write_net_rules
%{_libdir}/%{sname}/rules.d/*.rules
%{_libdir}/%{sname}/ata_id
%{_libdir}/%{sname}/cdrom_id
%{_libdir}/%{sname}/collect
%{_libdir}/%{sname}/dmi_memory_id
%{_libdir}/%{sname}/fido_id
%{_libdir}/%{sname}/mtd_probe
%{_libdir}/%{sname}/scsi_id
%{_libdir}/%{sname}/v4l_id
%{_mandir}/man5/*.5.gz
%{_mandir}/man7/*.7.gz
%{_mandir}/man8/*.8.gz
%{_defaultdocdir}/%{sname}-%{lfsvers}/*

#-----------------------------------------------------------------------------
%post
#to take care of new hardware definition
/sbin/udevadm hwdb --update


#=============================================================================
%package		libs
Summary		:	Shared library to access udev device information

#-----------------------------------------------------------------------------
%description		libs 
This package provides shared library to access eudev device information

#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%{_libdir}/lib%{sname}.so.*

#=============================================================================
%package		devel
Summary		:	Development libraries for eudev

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel 
Header and Library files for doing development with the eudev.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/*.h
%{_libdir}/lib%{sname}.so
%{_libdir}/pkgconfig/lib%{sname}.pc
%{_datadir}/pkgconfig/%{sname}.pc

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}
tar xf %{SOURCE2}

#-----------------------------------------------------------------------------
#building application
%build

autoreconf -vifs
./configure						\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
        --bindir=%{_bindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-split-usr				\
	--enable-hwdb					\
	--with-rootlibdir=%{_libdir}			\
	--with-rootprefix=				\
	--enable-blkid					\
	--enable-manpages				\
	--disable-static				\
	--config-cache					\
	--disable-rule-generator			\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#adjusting installation
#%{__mv}							\
#	%{buildroot}/bin/udevadm			\
#	%{buildroot}%{_bindir}/udevadm
#%{__ln} -nfs						\
#	../bin/udevadm					\
#	%{buildroot}%{_sbindir}
	
%{__mkdir_p}						\
	%{buildroot}%{_libdir}

%{__make} 						\
	-f udev-lfs-%{lfsvers}/Makefile.lfs		\
	DESTDIR=%{buildroot}				\
	install

#adding rules
%{__cp} -a						\
	%{name}-ok_addon/rules.d/*.rules		\
	%{buildroot}%{_libdir}/%{sname}/rules.d

sed -i							\
  -e 's/GROUP="sgx",//'					\
  %{buildroot}%{_libdir}/%{sname}/rules.d/50-udev-default.rules

sed -i							\
  -e 's/^TAG==/#TAG==/'					\
  %{buildroot}%{_libdir}/%{sname}/rules.d/73-seat-late.rules

#to add the init scipt
%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d		\
	%{buildroot}%{_sysconfdir}/rc.d/rcS.d
%{__cp} -a						\
	%{name}-ok_addon/%{name}.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{sname}
%{__ln_s}						\
	../init.d/%{sname}				\
	%{buildroot}%{_sysconfdir}/rc.d/rcS.d/S10%{sname}

#removing absolute symlink
%{__ln_s} -nsf						\
	../bin/udevadm					\
	%{buildroot}%{_sbindir}/udevadm
	
#To remove libtool library
find 							\
	%{buildroot}/%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
